# Struct ron::ser::PrettyConfig

source · [−]

    pub struct PrettyConfig {
        pub depth_limit: usize,
        pub new_line: String,
        pub indentor: String,
        pub separator: String,
        pub struct_names: bool,
        pub separate_tuple_members: bool,
        pub enumerate_arrays: bool,
        pub decimal_floats: bool,
        pub extensions: Extensions,
        pub compact_arrays: bool,
        /* private fields */
    }

Expand description

Pretty serializer configuration.

## Examples

    use ron::ser::PrettyConfig;

    let my_config = PrettyConfig::new()
        .depth_limit(4)
        // definitely superior (okay, just joking)
        .indentor("\t".to_owned());

## Fields

`depth_limit: usize`

Limit the pretty-ness up to the given depth.

`new_line: String`

New line string

`indentor: String`

Indentation string

`separator: String`

Separator string

`struct_names: bool` `separate_tuple_members: bool`

Separate tuple members with indentation

`enumerate_arrays: bool`

Enumerate array items in comments

`decimal_floats: bool`

Always include the decimal in floats

`extensions: Extensions`

Enable extensions. Only configures ‘implicit_some’ and ‘unwrap_newtypes’ for now.

`compact_arrays: bool`

Enable compact arrays

## Implementations

source

### impl PrettyConfig

source

#### pub fn new() -> Self

Creates a default `PrettyConfig`.

source

#### pub fn depth_limit(self, depth_limit: usize) -> Self

Limits the pretty-formatting based on the number of indentations. I.e., with a depth limit of 5, starting with an element of depth (indentation level) 6, everything will be put into the same line, without pretty formatting.

Default: std::usize::MAX

source

#### pub fn new_line(self, new_line: String) -> Self

Configures the newlines used for serialization.

Default: `\r\n` on Windows, `\n` otherwise

source

#### pub fn indentor(self, indentor: String) -> Self

Configures the string sequence used for indentation.

Default: 4 spaces

source

#### pub fn separator(self, separator: String) -> Self

Configures the string sequence used to separate items inline.

Default: 1 space

source

#### pub fn struct_names(self, struct_names: bool) -> Self

Configures whether to emit struct names.

Default: `false`

source

#### pub fn separate_tuple_members(self, separate_tuple_members: bool) -> Self

Configures whether tuples are single- or multi-line. If set to `true`, tuples will have their fields indented and in new lines. If set to `false`, tuples will be serialized without any newlines or indentations.

Default: `false`

source

#### pub fn enumerate_arrays(self, enumerate_arrays: bool) -> Self

Configures whether a comment shall be added to every array element, indicating the index.

Default: `false`

source

#### pub fn decimal_floats(self, decimal_floats: bool) -> Self

Configures whether floats should always include a decimal. When false `1.0` will serialize as `1` When true `1.0` will serialize as `1.0`

Default: `true`

source

#### pub fn compact_arrays(self, compact_arrays: bool) -> Self

Configures whether every array should be a single line (true) or a multi line one (false) When false, `["a","b"]` (as well as any array) will serialize to `[ "a", "b", ]` When true, `["a","b"]` (as well as any array) will serialize to `["a","b"]`

Default: `false`

source

#### pub fn extensions(self, extensions: Extensions) -> Self

Configures extensions

Default: Extensions::empty()

## Trait Implementations

source

### impl Clone for PrettyConfig

source

#### fn clone(&self) -> PrettyConfig

Returns a copy of the value. Read more

1.0.0 · source

#### fn clone_from(&mut self, source: &Self)

Performs copy-assignment from `source`. Read more

source

### impl Debug for PrettyConfig

source

#### fn fmt(&self, f: &mut Formatter<'_>) -> Result

Formats the value using the given formatter. Read more

source

### impl Default for PrettyConfig

source

#### fn default() -> Self

Returns the “default value” for a type. Read more

source

### impl<'de> Deserialize<'de> for PrettyConfig where
PrettyConfig: Default,

source

#### fn deserialize<__D>(__deserializer: __D) -> Result<Self, __D::Error> where
__D: Deserializer<'de>,

Deserialize this value from the given Serde deserializer. Read more

source

### impl Serialize for PrettyConfig

source

#### fn serialize<__S>(&self, __serializer: __S) -> Result<__S::Ok, __S::Error> where
__S: Serializer,

Serialize this value into the given Serde serializer. Read more

## Auto Trait Implementations

### impl RefUnwindSafe for PrettyConfig

### impl Send for PrettyConfig

### impl Sync for PrettyConfig

### impl Unpin for PrettyConfig

### impl UnwindSafe for PrettyConfig

## Blanket Implementations

source

### impl<T> Any for T where
T: 'static + ?Sized,

source

#### fn type_id(&self) -> TypeId

Gets the `TypeId` of `self`. Read more

source

### impl<T> Borrow<T> for T where
T: ?Sized,

const: unstable · source

#### fn borrow(&self) -> &T

Immutably borrows from an owned value. Read more

source

### impl<T> BorrowMut<T> for T where
T: ?Sized,

const: unstable · source

#### fn borrow_mut(&mut self) -> &mut T

Mutably borrows from an owned value. Read more

source

### impl<T> From<T> for T

const: unstable · source

#### fn from(t: T) -> T

Returns the argument unchanged.

source

### impl<T, U> Into<U> for T where
U: From<T>,

const: unstable · source

#### fn into(self) -> U

Calls `U::from(self)`.

That is, this conversion is whatever the implementation of `From<T> for U` chooses to do.

source

### impl<T> ToOwned for T where
T: Clone,

#### type Owned = T

The resulting type after obtaining ownership.

source

#### fn to_owned(&self) -> T

Creates owned data from borrowed data, usually by cloning. Read more

source

#### fn clone_into(&self, target: &mut T)

Uses borrowed data to replace owned data, usually by cloning. Read more

source

### impl<T, U> TryFrom<U> for T where
U: Into<T>,

#### type Error = Infallible

The type returned in the event of a conversion error.

const: unstable · source

#### fn try_from(value: U) -> Result<T, <T as TryFrom<U>>::Error>

Performs the conversion.

source

### impl<T, U> TryInto<U> for T where
U: TryFrom<T>,

#### type Error = <U as TryFrom<T>>::Error

The type returned in the event of a conversion error.

const: unstable · source

#### fn try_into(self) -> Result<U, <U as TryFrom<T>>::Error>

Performs the conversion.

source

### impl<T> DeserializeOwned for T where
T: for<'de> Deserialize<'de>,